## org.eclipse.emf.common.util
Class BasicDiagnostic

    java.lang.Object
      org.eclipse.emf.common.util.BasicDiagnostic

All Implemented Interfaces:
  Diagnostic, DiagnosticChain

    public class BasicDiagnostic

extends java.lang.Object
implements Diagnostic, DiagnosticChain

A basic implementation of a diagnostic that that also acts as a chain.

Field Summary
`protected java.util.List<Diagnostic>` `children` The message.
`protected int` `code` The code.
`protected java.util.List<?>` `data` The data.
`protected java.lang.String` `message` The message.
`protected int` `severity` The severity.
`protected java.lang.String` `source` The source.

Fields inherited from interface org.eclipse.emf.common.util.Diagnostic
`CANCEL, CANCEL_INSTANCE, ERROR, INFO, OK, OK_INSTANCE, WARNING`

Constructor Summary
`BasicDiagnostic()` Default Constructor (no initialization for local parameters)
`BasicDiagnostic(int severity, java.lang.String source, int code, java.lang.String message, java.lang.Object[] data)`
`BasicDiagnostic(java.lang.String source, int code, java.util.List<? extends Diagnostic> children, java.lang.String message, java.lang.Object[] data)`
`BasicDiagnostic(java.lang.String source, int code, java.lang.String message, java.lang.Object[] data)`

Method Summary
`void` `add(Diagnostic diagnostic)` Adds the diagnostic to the chain.
`void` `addAll(Diagnostic diagnostic)` Adds the `children` of the diagnostic to the chain.
`protected java.util.List<?>` `dataAsList(java.lang.Object[] data)`
`java.util.List<Diagnostic>` `getChildren()` Returns the list of child `diagnostics`.
`int` `getCode()` Returns `source-specific` identity code.
`java.util.List<?>` `getData()` Returns the arbitrary associated list of data.
`java.lang.Throwable` `getException()` Returns the first throwable object available in the `data` list, which is set when this diagnostic is instantiated.
`java.lang.String` `getMessage()` Returns a message describing the situation.
`int` `getSeverity()` Returns an indicator of the severity of the problem.
`java.lang.String` `getSource()` Returns the unique identifier of the source.
`void` `merge(Diagnostic diagnostic)` If the diagnostic has `children`, `add`s those children, otherwise, `add`s the diagnostic.
`int` `recomputeSeverity()`
`protected void` `setCode(int code)`
`protected void` `setSeverity(int severity)`
`protected void` `setSource(java.lang.String source)`
`static Diagnostic` `toDiagnostic(IStatus status)`
`static Diagnostic` `toDiagnostic(java.lang.Throwable throwable)` Returns the throwable viewed as a `Diagnostic`.
`static IStatus` `toIStatus(Diagnostic diagnostic)` Returns the diagnostic viewed as an `IStatus`.
`static IStatus` `toIStatus(DiagnosticException diagnosticException)` Returns the diagnostic exception viewed as an `IStatus`.
`java.lang.String` `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### severity

    protected int severity

  The severity.

  See Also:
    `getSeverity()`

### message

    protected java.lang.String message

  The message.

  See Also:
    `getMessage()`

### children

    protected java.util.List<Diagnostic> children

  The message.

  See Also:
    `getMessage()`

### data

    protected java.util.List<?> data

  The data.

  See Also:
    `getData()`

### source

    protected java.lang.String source

  The source.

  See Also:
    `getSource()`

### code

    protected int code

  The code.

  See Also:
    `getCode()`

Constructor Detail

### BasicDiagnostic

    public BasicDiagnostic()

  Default Constructor (no initialization for local parameters)

### BasicDiagnostic

    public BasicDiagnostic(java.lang.String source,
                           int code,
                           java.lang.String message,
                           java.lang.Object[] data)

### BasicDiagnostic

    public BasicDiagnostic(int severity,
                           java.lang.String source,
                           int code,
                           java.lang.String message,
                           java.lang.Object[] data)

### BasicDiagnostic

    public BasicDiagnostic(java.lang.String source,
                           int code,
                           java.util.List<? extends Diagnostic> children,
                           java.lang.String message,
                           java.lang.Object[] data)

Method Detail

### dataAsList

    protected java.util.List<?> dataAsList(java.lang.Object[] data)

### setSeverity

    protected void setSeverity(int severity)

### getSeverity

    public int getSeverity()

  Description copied from interface: `Diagnostic`
  Returns an indicator of the severity of the problem.

  Specified by:
    `getSeverity` in interface `Diagnostic`

### getMessage

    public java.lang.String getMessage()

  Description copied from interface: `Diagnostic`
  Returns a message describing the situation.

  Specified by:
    `getMessage` in interface `Diagnostic`

### getData

    public java.util.List<?> getData()

  Description copied from interface: `Diagnostic`
  Returns the arbitrary associated list of data. The first element is typically the object that is the primary source of the problem; the second element is typically some object describing the problematic feature or aspect of the primary source, and the remaining elements are additional objects associated with or describing the problem.

  Specified by:
    `getData` in interface `Diagnostic`

### getChildren

    public java.util.List<Diagnostic> getChildren()

  Description copied from interface: `Diagnostic`
  Returns the list of child `diagnostics`.

  Specified by:
    `getChildren` in interface `Diagnostic`

### setSource

    protected void setSource(java.lang.String source)

### getSource

    public java.lang.String getSource()

  Description copied from interface: `Diagnostic`
  Returns the unique identifier of the source.

  Specified by:
    `getSource` in interface `Diagnostic`

### setCode

    protected void setCode(int code)

### getCode

    public int getCode()

  Description copied from interface: `Diagnostic`
  Returns `source-specific` identity code.

  Specified by:
    `getCode` in interface `Diagnostic`

### add

    public void add(Diagnostic diagnostic)

  Description copied from interface: `DiagnosticChain`
  Adds the diagnostic to the chain.

  Specified by:
    `add` in interface `DiagnosticChain`

### addAll

    public void addAll(Diagnostic diagnostic)

  Description copied from interface: `DiagnosticChain`
  Adds the `children` of the diagnostic to the chain.

  Specified by:
    `addAll` in interface `DiagnosticChain`

### merge

    public void merge(Diagnostic diagnostic)

  Description copied from interface: `DiagnosticChain`
  If the diagnostic has `children`, `add`s those children, otherwise, `add`s the diagnostic.

  Specified by:
    `merge` in interface `DiagnosticChain`

### recomputeSeverity

    public int recomputeSeverity()

### getException

    public java.lang.Throwable getException()

  Returns the first throwable object available in the `data` list, which is set when this diagnostic is instantiated.

  Specified by:
    `getException` in interface `Diagnostic`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### toIStatus

    public static IStatus toIStatus(Diagnostic diagnostic)

  Returns the diagnostic viewed as an `IStatus`.

### toIStatus

    public static IStatus toIStatus(DiagnosticException diagnosticException)

  Returns the diagnostic exception viewed as an `IStatus`.

### toDiagnostic

    public static Diagnostic toDiagnostic(IStatus status)

### toDiagnostic

    public static Diagnostic toDiagnostic(java.lang.Throwable throwable)

  Returns the throwable viewed as a `Diagnostic`.

  Parameters:
    `throwable` -
  Returns:
    `Diagnostic`

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.